;-----------------------------------------------------
; sample1.asm - Copyright (C) Mikael Sundberg 1999
;-----------------------------------------------------

	include "savelib.h"
	include "doorsos.h"
	include "userlib.h"
	include "graphlib.h"

	xdef _main
	xdef _comment
	xdef _ti89

;-----------------------------------------------------
; Main
;-----------------------------------------------------

_main:	; @@ NOTE! This program will display "file not found" becaus we 
	; @@ override the default "ignore file not found" option, it will also 
	; @@ create a hidden file named 'sample3' in a folder named 'youne'

	; @@ Tell savelib to use flags in sl_flgs instead of 
	; @@ it's own flags, this could be useful if you would 
	; @@ like to change the behavior of the library. This 
	; @@ feature should be used as little as possible because 
	; @@ it is possible for the user to change the default 
	; @@ flags using the slconf utility. This will override 
	; @@ the users settings.

	lea	sl_flgs(pc),a0			; @@ Load pointer to flags into a0
	move.l	a0,(savelib::oflags)		; @@ Copy pointer from a0 to savelib::oflags
	
	; @@ Tell savelib to save to folder in <sl_fold> instead of the default
	; @@ Should also be used as little as possible
	
	lea	sl_fold(pc),a0			; @@ Load pointer to folder-name into a0
	move.l	a0,(savelib::ofolder)		; @@ Copy pointer from a0 to savelib::ofolder
	
	; @@ Load data from file using savelib
	; @@ The name of the file the data will be loaded 
	; @@ from is pointed to by <sl_name>. Data will be 
	; @@ written to memory that starts at <sl_start> and 
	; @@ ends at <sl_end>.

	savelib::eloadm sl_name,sl_start,sl_end

\loaded	jsr	graphlib::clr_scr		; Clear screen
	
	SetFont #1				; Set font..
	
	WriteStrA #30,#25,#2,#string		; Display string
	
	move.w	#30,d1				; X-pos
	move.w	#65,d2				; Y-pos
	move.w	#10,d3				; Maxlength of text
	
	jsr	userlib::InputStr		; Read text
		
	cmp	#0,d0				; Check if something was read
	beq	\skip
	
	move.w	#10,d0				; Copy data read to string
	lea	string,a1				; ..
\loop	move.b	(a0)+,(a1)+			; ..
	dbra	d0,\loop			; ..

	; @@ We must set the custom flags and folder again because all 
	; @@ savelib functions clears them after execution.

	lea	sl_flgs(pc),a0			; @@ Load pointer to flags into a0
	move.l	a0,(savelib::oflags)		; @@ Copy pointer from a0 to savelib::oflags
	lea	sl_fold(pc),a0			; @@ Load pointer to folder-name into a0
	move.l	a0,(savelib::ofolder)		; @@ Copy pointer from a0 to savelib::ofolder
	
	; @@ Save data to file using savelib
	; @@ The name of the file the data will be saved 
	; @@ to is pointed to by <sl_name>. Data will be 
	; @@ read from memory that starts at <sl_start> and 
	; @@ ends at <sl_end>.

\skip	savelib::esavem sl_name,sl_start,sl_end
	
	rts

;-----------------------------------------------------
; Program comment
;-----------------------------------------------------

_comment dc.b "Savelib sample 3",0
	
;-----------------------------------------------------
; Variables
;-----------------------------------------------------

sl_name	dc.b "sample3",0			; @@ Filename used by savelib

sl_fold	dc.b "youne",0				; @@ Store file in folder 'youne'
sl_flgs dc.b %00000110				; @@ Flags (auto create folder, hide created files)

sl_start					; @@ Savelib starts reading/writing data here
string	dc.b "ABCDEFGHIJ",0			; @@ String that will be saved
sl_end						; @@ Savelib ends reading/writing data here

	end