;-----------------------------------------------------
; savelib.h - Copyright (C) Mikael Sundberg 1999
;-----------------------------------------------------

savelib::savem macro; filename, start_label, end_label
	movem.l	a0-a1,-(a7)
	lea	\1,a0
	lea	\2,a1
	move.l	#\3-\2,d0
	jsr	savelib::save
	movem.l	(a7)+,a0-a1
	endm

savelib::loadm macro; filename, start_label, end_label
	movem.l	a0-a2,-(a7)
	lea	\1,a0
	lea	\2,a1
	move.l	#\3-\2,d0
	jsr	savelib::load
	movem.l	(a7)+,a0-a2
	endm
	
savelib::esavem macro; filename, start_label, end_label
	movem.l	a0-a2,-(a7)
	lea	\1,a0
	lea	\2,a1
	move.l	#\3-\2,d0
	jsr	savelib::save
	jsr	savelib::errmsg
	movem.l	(a7)+,a0-a2
	endm

savelib::eloadm macro; filename, start_label, end_label
	movem.l	a0-a2,-(a7)
	lea	\1,a0
	lea	\2,a1
	move.l	#\3-\2,d0
	jsr	savelib::load
	jsr	savelib::errmsg
	movem.l	(a7)+,a0-a2
	endm

;-----------------------------------------------------
; save - Save data to file
;  I:	d0.w - Data size
;	a0.l - Filename pointer
;	a1.l - Data pointer
;  O:	d0.w - Data saved, bit0 = 1 : yes
;	d1.w - Error code if error, else 0
;-----------------------------------------------------
savelib::save		equ	savelib@0001



;-----------------------------------------------------
; load - Load data from file
;  I:	d0.l - Data size
;	a0.l - Filename pointer
;	a1.l - Data pointer
;  O:	d0.w - Data loaded, bit0 = 1 : yes
;	d1.w - Error code if error, else 0
;-----------------------------------------------------
savelib::load		equ	savelib@0000



;-----------------------------------------------------
; errstr - Get error string
;  I:	d1.w - Error code
;  O:	a0.w - Pointer to error string
;-----------------------------------------------------
savelib::errstr		equ	savelib@0002



;----------------------------------------------------
; errmsg - Show error message
;  I:	d1.w - Error code
;-----------------------------------------------------
savelib::errmsg		equ	savelib@0003



;-----------------------------------------------------
; Variables
;-----------------------------------------------------
savelib::oflags		equ	savelib@0004
savelib::ofolder	equ	savelib@0005
savelib::folder		equ	savelib@0006
savelib::flags		equ	savelib@0007
savelib::log		equ	savelib@0008

